#include <stdio.h>
#include <conio.h>
#include <string.h>

int items, selected=0;
char paths[100][256];	// max 100
char *path;
char dir[256];
char file[256];
char name[256];

void Select(int i)
{
	path = paths[i];
	strcpy(dir, path);
	char *p = strrchr(dir, '\\');
	*p = 0;
	strcpy(file, p+1);
	strcpy(name, file);
	p = strrchr(name, '.');
	*p = 0;
}

void WriteBatch(int i)	// i<0 : exit
{
	FILE *f = fopen("\\1.bat", "wt");
	fprintf(f, "@echo off\n");
	fprintf(f, "cd \\\n");
	fprintf(f, "1.exe\n");
	if (i >= 0)
	{
		Select(i);
		fprintf(f, "cd %s\n", dir);
		fprintf(f, "call %s\n", file);
		fprintf(f, "cd \\\n");
		fprintf(f, "1.bat\n");
	}
	fclose(f);
}

void DrawItem(int i)
{
	Select(i);
	gotoxy(3+i/20*20, 4+i%20);
	if (i == selected) textcolor(15); else textcolor(7);
	cprintf("%s", name);
}


void main()
{
	clrscr();

	// read items
	strcpy(paths[0], "\\<make selection>");
	DrawItem(0);
	items=1;
	FILE *f = fopen("1", "rt");
	while (1)
	{
		char s[256], *p;
		if (!fgets(s, 256, f)) break;
		p = strrchr(s, '\n');
		*p = 0;
		if (s[0] == 0) break;
		strcpy(paths[items], s);
		DrawItem(items);
		items++;
	}
	fclose(f);

	// selection
	while (1)
	{
		int c = getch();

		if (c == 27)
		{
			WriteBatch(-1);
			break;
		}

		if (c == 13)
		{
			Select(selected);
			if (dir[0])
			{
				WriteBatch(selected);
				break;
			}
		}

		if (c == 'H')	// up
		{
			int oselected = selected;
			selected--;
			if (selected < 0) selected = 0;
			if (selected >= items) selected = items-1;
			DrawItem(oselected);
			DrawItem(selected);
		}

		if (c == 'P')	// down
		{
			int oselected = selected;
			selected++;
			if (selected < 0) selected = 0;
			if (selected >= items) selected = items-1;
			DrawItem(oselected);
			DrawItem(selected);
		}

		if (c == 'K')	// left
		{
			int oselected = selected;
			selected -= 20;
			if (selected < 0) selected = 0;
			if (selected >= items) selected = items-1;
			DrawItem(oselected);
			DrawItem(selected);
		}

		if (c == 'M')	// right
		{
			int oselected = selected;
			selected += 20;
			if (selected < 0) selected = 0;
			if (selected >= items) selected = items-1;
			DrawItem(oselected);
			DrawItem(selected);
		}

	}

	clrscr();
}
